{$A+,B-,D-,E-,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X-,Y-}

USES
  dos;

LABEL
  1, 2, 3, 4, 5, 7;

CONST
  am: string[127] = 'Data Searcher v1.00 IX-1996 by V. Lidovski';
  b = 1024;
  dB = 62*1024;
  cB = 63*1024;

TYPE
  mbuf2 = array [1..(dB+b)] of byte;
  mbuf1 = array [1..cB] of byte;

VAR
  r: registers;
  f1, f2: file;
  fs1, fs1m, fs2, p2: longint;
  b2: ^mbuf2;
  b1: ^mbuf1;
  t1, t1o, i, o2, s2, c1: word;
  k: integer;
  xf: boolean;

FUNCTION min(a,b:longint):longint;
 begin
   if a > b then
     min := b
   else
     min := a
 end;

PROCEDURE outerr;
  begin
    r.ah := $40;
    r.bx := 2;
    r.ds := dseg;
    r.dx := ofs(am) + 1;
    am := am + #$d#$a;
    r.cx := length(am);
    msdos(r)
  end;

BEGIN
  outerr;
  if am[38] <> 'o' then
    goto 1;
  case paramcount of
    2, 3:
    begin
      filemode := 0;
      assign(f1, paramstr(1));
{$I-}
      reset(f1,1);
      if ioresult <> 0 then begin
        am := 'Can''t find ' + paramstr(1);
        outerr;
        halt(1)
      end;
      assign(f2, paramstr(2));
      reset(f2, 1);
      if ioresult <> 0 then begin
        am := 'Can''t find ' + paramstr(2);
        outerr;
        halt(2)
      end;
{$I+}
      if paramcount = 3 then begin
        val(paramstr(3), p2, k);
        if p2 < 1 then begin
          am := 'Illegal parameter: ' + paramstr(3);
          outerr;
          goto 2
        end;
        dec(p2)
      end else
        p2 := 0;
      fs1 := filesize(f1);
      fs2 := filesize(f2);
      if fs1 > fs2 then begin
        am := paramstr(1) + ' is greater than ' + paramstr(2);
        outerr;
        goto 7
      end;
      new(b1);
      new(b2);
    3:xf := false;
      t1 := min(b, fs1);
      blockread(f1, b1^, t1);
    4:if xf then begin
        seek(f1,0);
        goto 3
      end;
      o2 := 0;
      seek(f2, p2);
      c1 := min(dB, fs2 - t1 - p2);
      blockread(f2, b2^, t1 + c1);
      fs1m := fs1;
      s2 := 0;
      repeat
      5:for i := 1 to t1 do
          if b1^[i] <> b2^[i + o2] then begin
            if xf then
              p2 := p2 + s2 + 1
            else
              if o2<c1 then begin
                inc(o2);
                inc(s2);
                goto 5
              end else
                p2 := p2 + c1 + 1;
              if fs2 - p2 >= t1 then
                goto 4;
          7:writeln('SET DASE=0');
            goto 1
          end;
        fs1m := fs1m - t1;
        t1o := t1;
        t1 := min(fs1m, cB);
        if t1 = 0 then begin
          writeln('SET DASE=', p2 + s2 + 1);
          goto 1
        end;
        xf := true;
        blockread(f1, b1^, t1);
        if c1 -o2 >= t1 then
          o2 := o2 + t1o
        else begin
          move(b2^[t1o + o2 + 1], b2^[1], c1 - o2);
          blockread(f2, b2^[c1 - o2 + 1], t1 + o2 - c1);
          o2 := 0;
          c1 := 0
        end
      until false;
    1:close(f1);
      close(f2)
    end else begin
    2:am :=
      'USAGE: dase <file with searched data> <looked file> [<start position>]';
      outerr;
      halt(3)
    end
  end
END.

